/*
 *
 * This code is sample code, provided as-is, and we make no
 * warranties as to its correctness or suitablity for
 * any purpose.
 *
 * We hope that it's useful to you.  Enjoy.
 * Copyright 2008 LearningPatterns Inc.
 */

import java.math.BigDecimal;
import java.sql.Date;

import com.javatunes.persist.MusicItem;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;

public class TestHibernate {

	public static void main(String[] args) {

		SessionFactory sf;
		Session s;

		try {
			sf = new Configuration().configure().buildSessionFactory();
			s = sf.openSession();

			System.out.println("Session connect status: " + s.isConnected());

			String newItemNum = "CD525";
			if (args.length != 0) {
				newItemNum=args[0];
			}

			MusicItem mItem = new MusicItem();
			mItem.setNum(newItemNum);
			mItem.setTitle("Foo");
			mItem.setArtist("me");
			mItem.setReleaseDate(new Date(System.currentTimeMillis()));
			mItem.setListPrice(new BigDecimal("25.00"));
			mItem.setPrice(new BigDecimal("14.99"));
			System.out.println("Created MusicItem: " + mItem);

			// Saving a new entity
			Transaction tx = s.beginTransaction();
			Long newId = (Long)s.save(mItem);
			System.out.println("Saved ItemVal: " + mItem.getId());
			tx.commit();

			// Modifying an entity
			Long modId = 5l;
			tx=s.beginTransaction();
			mItem = (MusicItem)s.get(MusicItem.class, modId);
			System.out.println("Retrieved MusicItem with id, Num: " + newId + ", " + mItem.getNum());
			mItem.setTitle("This is a new Title");
			tx.commit();

			// Deleting an entity
			Long delId = 12l;
			tx=s.beginTransaction();
			mItem = (MusicItem)s.load(MusicItem.class, delId);
			s.delete(mItem);
			tx.commit();

			System.out.println("After commit session open state = " + s.isOpen());
			
			s.close();
 		    sf.close();

		} catch (HibernateException e) {
			e.printStackTrace();
		}
		catch (Exception ex) { ex.printStackTrace(); }
	}

}
